# Define version and release number
%define php_common_major 8
%define php_common_sub 4
%define phplong %{php_common_major}.%{php_common_sub}
%define modname pear
%global	__requires_exclude pear\\((PHPUnit.*|PEAR.*)\\)
%define Archive_Tar_version 1.5.0
%define Console_Getopt_version 1.4.3
%define Structures_Graph_version 1.1.1
%define XML_Util_version 1.4.5
%define inidir %(php-config%{phplong} --ini-dir)

Summary:	PHP Extension and Application Repository
Name:		php%{phplong}-%{modname}
Epoch:		1
Version:	1.10.16
Release:	%mkrel 7
License:	PHP License
Group:		Development/PHP
URL:		https://pear.php.net/package/PEAR/
Source0:	https://pear.php.net/get/PEAR-%{version}.tgz
Source1:	install-pear.php
Source2:	relocate.php
Source3:	strip.php
Source4:	LICENSE
Source5:	pear.script
Source10:	pear.sh
Source11:	pecl.sh
Source12:	peardev.sh
Source21:	https://pear.php.net/get/Archive_Tar-%{Archive_Tar_version}.tgz
Source22:	https://pear.php.net/get/Console_Getopt-%{Console_Getopt_version}.tgz
Source23:	https://pear.php.net/get/Structures_Graph-%{Structures_Graph_version}.tgz
Source24:	https://pear.php.net/get/XML_Util-%{XML_Util_version}.tgz
BuildRequires:	php-cli >= 3:%{phplong}.0, php-cli <= 3:%{phplong}.99
Obsoletes:	php-pear-Console_Getopt < %{Console_Getopt_version}
Obsoletes:	php-pear-Archive_Tar < %{Archive_Tar_version}
Obsoletes:	php-pear-Structures_Graph < %{Structures_Graph_version}
Obsoletes:	php-pear-XML_Util < %{XML_Util_version}
Obsoletes:	php%{phplong}-%{modname} <= 3:%{phplong}
BuildArch:	noarch
Requires:	php >= 3:%{phplong}.0
Requires:	php-common = 3:%{phplong}
Requires:	php-cli >= 3:%{phplong}.0,php-cli <= 3:%{phplong}.99
Requires:	php-filter >= 3:%{phplong}.0,php-filter <= 3:%{phplong}.99
Requires:	php-zlib >= 3:%{phplong}.0,php-zlib <= 3:%{phplong}.99
Requires:	php-openssl >= 3:%{phplong}.0, php-openssl <= 3:%{phplong}.99
Provides:	php-%{modname} = %{version}
Provides:	php-pear-Console_Getopt = %{Console_Getopt_version}
Provides:	pear(Console/Getopt.php) = %{Console_Getopt_version}
Provides:	php-pear-Archive_Tar = %{Archive_Tar_version}
Provides:	php-pear-Structures_Graph = %{Structures_Graph_version}
Provides:	php-pear-XML_Util = %{XML_Util_version}
Provides:	php-pear = %{epoch}:%{version}
# the russian roulette fix - start
# this reduces breakage going from php-pear-5.2.x
Provides:	pear = %{epoch}:%{version}
Provides:	php-pear-PEAR = %{epoch}:%{version}
Provides:	php-pear-PEAR-Command = %{epoch}:%{version}
Provides:	php-pear-PEAR-Frontend_CLI = %{epoch}:%{version}
Provides:	php-pear-PEAR-OS = %{epoch}:%{version}

%description 
PEAR is short for "PHP Extension and Application Repository" and is pronounced
just like the fruit. The purpose of PEAR is to provide:

 * A structured library of open-sourced code for PHP users
 * A system for code distribution and package maintenance
 * A standard style for code written in PHP
 * The PHP Foundation Classes (PFC)
 * The PHP Extension Code Library (PECL)
 * A web site, mailing lists and download mirrors to support the PHP/PEAR
   community

%prep
%setup -q -cT

# Create a usable PEAR directory (used by install-pear.php)
for archive in %{SOURCE0} %{SOURCE21} %{SOURCE22} %{SOURCE23} %{SOURCE24}; do
    tar xzf $archive --strip-components 1
    cp $archive .
    gunzip `basename $archive`
done
tar xzf %{SOURCE24} package.xml
mv package.xml XML_Util.xml

%autopatch -p1

%build

%install
export PHP_PEAR_SYSCONF_DIR=%{_sysconfdir}
export PHP_PEAR_SIG_KEYDIR=%{_sysconfdir}/pearkeys
export PHP_PEAR_SIG_BIN=%{_bindir}/gpg
export PHP_PEAR_INSTALL_DIR=%{_datadir}/pear

# 1.4.11 tries to write to the cache directory during installation
# so it's not possible to set a sane default via the environment.
# The ${PWD} bit will be stripped via relocate.php later.
export PHP_PEAR_CACHE_DIR=${PWD}%{_localstatedir}/cache/php-pear
export PHP_PEAR_TEMP_DIR=/var/tmp

install -d \
    %{buildroot}%{_datadir}/pear \
    %{buildroot}%{_localstatedir}/cache/php-pear \
    %{buildroot}%{_localstatedir}/www/html \
    %{buildroot}%{_datadir}/pear/.pkgxml \
    %{buildroot}%{_sysconfdir}/rpm \
    %{buildroot}%{_sysconfdir}/pear \
	%{buildroot}%{_bindir}

export INSTALL_ROOT=%{buildroot}

%{_bindir}/php \
    -n -dmemory_limit=64M -dshort_open_tag=0 -dsafe_mode=0 \
    -derror_reporting=E_ALL -ddetect_unicode=0 \
    %{SOURCE1} --force \
    --dir		%{buildroot}%{_datadir}/pear \
    --config	%{buildroot}%{_sysconfdir}/pear \
    --cache		%{buildroot}%{_localstatedir}/cache/php-pear \
    --bin		%{buildroot}%{_bindir} \
    --metadatadir %{buildroot}%{_datadir}/pear \
    --www		%{buildroot}%{_localstatedir}/www/html \
    `basename -s .tgz %{SOURCE0}`.tar `basename -s .tgz %{SOURCE20}`.tar `basename -s .tgz %{SOURCE21}`.tar `basename -s .tgz %{SOURCE22}`.tar `basename -s .tgz %{SOURCE23}`.tar `basename -s .tgz %{SOURCE24}`.tar

# Replace /usr/bin/* with simple scripts:
install -m 755 %{SOURCE10} %{buildroot}%{_bindir}/pear
install -m 755 %{SOURCE11} %{buildroot}%{_bindir}/pecl
install -m 755 %{SOURCE12} %{buildroot}%{_bindir}/peardev
install -m 644 scripts/*.php %{buildroot}%{_datadir}/pear

# Sanitize the pear.conf
%{_bindir}/php -n %{SOURCE2} %{buildroot}%{_sysconfdir}/pear.conf %{buildroot} |
%{_bindir}/php -n %{SOURCE2} php://stdin $PWD > new-pear.conf
%{_bindir}/php -n %{SOURCE3} new-pear.conf ext_dir |
%{_bindir}/php -n %{SOURCE3} php://stdin http_proxy > %{buildroot}%{_sysconfdir}/pear.conf

%{_bindir}/php -r "print_r(unserialize(substr(file_get_contents('%{buildroot}%{_sysconfdir}/pear.conf'),17)));"

#Sanitize the registry
for file in `ls %{buildroot}%{_datadir}/pear/.registry/*.reg`; do
	%{_bindir}/php -n %{SOURCE2} ${file} %{buildroot} |
	%{_bindir}/php -n %{SOURCE2} php://stdin $PWD > tmp.reg
	mv tmp.reg ${file}
done

install -m 644 -c %{SOURCE4} LICENSE

# Why this file here ?
rm -rf %{buildroot}/.depdb* %{buildroot}/.lock %{buildroot}/.channels %{buildroot}/.filemap

#remove buildroot duplicate
rm -rf %{buildroot}/%{buildroot}
rm -rf %{buildroot}%{_datadir}/pear/test

# Need for re-registrying XML_Util
install -m 644 XML_Util.xml %{buildroot}%{_datadir}/pear/.pkgxml/

# for filetriggers:
install -d -m 755 %{buildroot}%{_prefix}/lib/rpm/
install -m 755 %{SOURCE5} \
    %{buildroot}%{_datadir}/pear/pear.script

%check
# Check that no bogus paths are left in the configuration, or in
# the generated registry files.
[ `grep -c %{buildroot} %{buildroot}%{_sysconfdir}/pear.conf` -eq 0 ]
[ `grep -c %{_libdir} %{buildroot}%{_sysconfdir}/pear.conf` -eq 0 ]
[ `grep -c '"/tmp"' %{buildroot}%{_sysconfdir}/pear.conf` -eq 0 ]
[ `grep -c /usr/local %{buildroot}%{_sysconfdir}/pear.conf` -eq 0 ]
[ `grep -rl %{buildroot} %{buildroot}|wc -l` -eq 0 ]

# Register newly installed PECL packages
%transfiletriggerin --  %{_datadir}/pear/packages/
%{_datadir}/pear/pear.script

%files
%doc LICENSE README.rst
%dir %{_sysconfdir}/pear
%config(noreplace) %{_sysconfdir}/pear.conf
%{_datadir}/pear
%{_bindir}/*
%dir %{_localstatedir}/cache/php-pear


%changelog
* Wed Mar 26 2025 mokraemer <mokraemer> 1:1.10.16-7.mga9
+ Revision: 2170077
- fix dep
- version bump
- Fixes for multiversion
- Fix packaging errors
- fix spec

* Mon Nov 25 2024 mokraemer <mokraemer> 1:1.10.16-1.mga10
+ Revision: 2118927
- new version 1.10.16

* Fri Sep 13 2024 mokraemer <mokraemer> 1:1.10.15-4.mga10
+ Revision: 2095773
- rebuild for php 8.4 release

* Thu Apr 04 2024 mokraemer <mokraemer> 1:1.10.15-3.mga10
+ Revision: 2054437
- remove php version - this is not version dependend

* Tue Mar 19 2024 mokraemer <mokraemer> 1:1.10.15-2.mga10
+ Revision: 2050941
- updated tar

* Sun Mar 10 2024 mokraemer <mokraemer> 1:1.10.15-1.mga10
+ Revision: 2049063
- new version 1.10.15

* Sat Jan 20 2024 mokraemer <mokraemer> 1:1.10.14-4.mga10
+ Revision: 2032729
- rebuild for include path change

* Thu Jan 18 2024 mokraemer <mokraemer> 3.mga10-current
+ Revision: 2032049
- support multiple php-versions
- support multiple php-versions
- prepare multi-php

* Mon Nov 27 2023 mokraemer <mokraemer> 1:1.10.14-1.mga10
+ Revision: 2010321
- remove obsolete patch
- new version 1.10.14

* Sun Nov 05 2023 mokraemer <mokraemer> 1:1.10.13-11.mga10
+ Revision: 2004619
- fix a typo in OS/Guess.php

* Fri Sep 08 2023 mokraemer <mokraemer> 1:1.10.13-10.mga10
+ Revision: 1985204
- rebuild for php 8.3

* Fri Jul 22 2022 mokraemer <mokraemer> 1:1.10.13-9.mga9
+ Revision: 1869990
- fix dependancy error

* Thu Jul 21 2022 mokraemer <mokraemer> 1:1.10.13-8.mga9
+ Revision: 1869859
- rebuild for php 8.2

* Sat Apr 30 2022 mokraemer <mokraemer> 1:1.10.13-7.mga9
+ Revision: 1855211
- fix pear builds with zlib extension

* Thu Apr 28 2022 mokraemer <mokraemer> 1:1.10.13-6.mga9
+ Revision: 1854929
- move obsoletes

* Thu Apr 21 2022 mokraemer <mokraemer> 1:1.10.13-5.mga9
+ Revision: 1852519
- new obsoletes

* Thu Apr 21 2022 mokraemer <mokraemer> 1:1.10.13-4.mga9
+ Revision: 1852276
- obsolete old pear packages

* Mon Mar 21 2022 umeabot <umeabot> 1:1.10.13-3.mga9
+ Revision: 1815716
- Mageia 9 Mass Rebuild

* Fri Nov 26 2021 mokraemer <mokraemer> 1:1.10.13-2.mga9
+ Revision: 1759376
- rebuild for php 8.1

* Wed Aug 11 2021 mokraemer <mokraemer> 1:1.10.13-1.mga9
+ Revision: 1741058
- new version 1.10.13

* Mon Aug 02 2021 mokraemer <mokraemer> 1:1.10.12-9.mga9
+ Revision: 1738618
- fixed pecl/pear script

* Mon Jul 26 2021 mokraemer <mokraemer> 1:1.10.12-8.mga9
+ Revision: 1737855
- update php-tar

* Mon May 10 2021 mokraemer <mokraemer> 1:1.10.12-7.mga9
+ Revision: 1722399
- updated tar

* Mon Apr 26 2021 tv <tv> 1:1.10.12-6.mga9
+ Revision: 1719907
- Do not put scripts under /var/lib/rpm
- kill very very old %%triggerpostun for php-pear-XML-Util

* Fri Jan 22 2021 mokraemer <mokraemer> 1:1.10.12-5.mga8
+ Revision: 1672856
- added php-filter as requirement

* Tue Jan 19 2021 mokraemer <mokraemer> 1:1.10.12-4.mga8
+ Revision: 1672500
- Fix CVE-2020-36193

* Fri Dec 11 2020 pterjan <pterjan> 1:1.10.12-3.mga8
+ Revision: 1655396
- Fix /usr/bin/pear crashing by loading filter instead of xml

* Wed Dec 02 2020 mokraemer <mokraemer> 1:1.10.12-2.mga8
+ Revision: 1651868
- fix CVE-2020-28948 and CVE-2020-28949 (mga#27664)

* Tue Apr 28 2020 luigiwalser <luigiwalser> 1:1.10.12-1.mga8
+ Revision: 1572989
- PEAR 1.10.12
- Archive_Tar 1.4.9
- Console_Getopt 1.4.3
- XML_Util_version 1.4.5

* Tue Apr 14 2020 mokraemer <mokraemer> 1:1.10.11-1.mga8
+ Revision: 1567268
- new version 1.10.11

* Tue Feb 18 2020 umeabot <umeabot> 1:1.10.10-3.mga8
+ Revision: 1539058
- Mageia 8 Mass Rebuild

* Fri Nov 29 2019 mokraemer <mokraemer> 1:1.10.10-2.mga8
+ Revision: 1463711
- rebuild pear

* Wed Nov 20 2019 mokraemer <mokraemer> 1:1.10.10-1.mga8
+ Revision: 1461888
- new version 1.10.10

* Fri Mar 15 2019 mokraemer <mokraemer> 1:1.10.9-1.mga7
+ Revision: 1377297
- new version 1.10.9

* Sat Mar 02 2019 mokraemer <mokraemer> 1:1.10.7-3.mga7
+ Revision: 1371064
- Fix pear missing xml

* Fri Mar 01 2019 mokraemer <mokraemer> 1:1.10.7-2.mga7
+ Revision: 1370821
- Fix warnings if php modules not updated before install (mga#24447)

* Sun Dec 30 2018 luigiwalser <luigiwalser> 1:1.10.7-1.mga7
+ Revision: 1347131
- 1.10.7
- update Archive_Tar to 1.4.4
- drop PHP 7.2 deprecated option, patch from
  https://github.com/pear/pear-core/pull/83

* Thu Sep 20 2018 umeabot <umeabot> 1:1.10.6-2.mga7
+ Revision: 1287662
- Mageia 7 Mass Rebuild

* Wed Aug 22 2018 mokraemer <mokraemer> 1:1.10.6-1.mga7
+ Revision: 1253507
- new version 1.10.6

* Sat Nov 25 2017 mokraemer <mokraemer> 1:1.10.5-1.mga7
+ Revision: 1179249
- updated version

* Mon Mar 14 2016 spuhler <spuhler> 1:1.10.1-3.mga6
+ Revision: 990392
- upgrade Archive_Tar to version 1.4.2
- Obsoleted the two separate packages that php-pear already provides
  * php-pear-Console_Getopt
  * php-pear-Structures_Graph
    - this fixes  Bug 17767and Bug 17768

* Fri Dec 18 2015 oden <oden> 1:1.10.1-2.mga6
+ Revision: 911629
- sync with fedora
- PEAR-1.10.1

* Wed Oct 07 2015 spuhler <spuhler> 1:1.10.0-1.mga6
+ Revision: 886922
- upgrade to vers 1.10.0
  * Archive_Tar_version 1.4.0
  * Console_Getopt_version 1.4.1
  * Structures_Graph_version 1.1.1
  * XML_Util_version 1.3.0

* Sun Sep 06 2015 tv <tv> 1:1.9.5-9.mga6
+ Revision: 873307
- switch to new upstream file trigger syntax

* Wed Oct 15 2014 umeabot <umeabot> 1:1.9.5-8.mga5
+ Revision: 743520
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1:1.9.5-7.mga5
+ Revision: 687170
- Mageia 5 Mass Rebuild
+ tv <tv>
- use %%global for req/prov exclude
- autoconvert to new prov/req excludes

* Tue Sep 09 2014 spuhler <spuhler> 1:1.9.5-6.mga5
+ Revision: 673897
- corrected spelling of Obsoletes: php-pear-Archive_Tar

* Tue Sep 09 2014 spuhler <spuhler> 1:1.9.5-5.mga5
+ Revision: 673833
- added Obsoletes: php-pear-Archive-Tar
  * this was build in error when pear was updated in june 2014
    - both packages contain php-Tar which creates a conflict

* Thu Sep 04 2014 spuhler <spuhler> 1:1.9.5-4.mga5
+ Revision: 672102
- upgrade Archive_Tar-1.3.12. to Archive_Tar-1.3.13

* Wed Aug 06 2014 spuhler <spuhler> 1:1.9.5-3.mga5
+ Revision: 660086
- updated Archive_Tar_version 1.3.11 to 1.3.12

* Mon Jul 21 2014 spuhler <spuhler> 1:1.9.5-2.mga5
+ Revision: 655342
- added deleted scripts and LICENSE files
- reversed rev. 651492 (pearizing of spec)
  * this doesn't work ans it doen't provide the /etc/pear.conf
  * location of pear files would be wrong.

* Sun Jul 13 2014 spuhler <spuhler> 1:1.9.5-1.mga5
+ Revision: 651560
- corrected the name and added Obsoletes to remove the wrongly named package
- deleted scripts and patches from <=1.9.4
- corrected Group
- upgrade to ver. 1.9.5
 * lots of bugfixes by upstream
- removed source files
 * Archive_Tar-1.3.11.tgz
 * Console_Getopt-1.3.1.tgz
 * Structures_Graph-1.0.4.tgz
 * XML_RPC-1.5.5.tgz  XML_Util-1.2.1.tgz
- they are now separate packages
- pearized spec file
- removed all patches and special scripts
  * upstream (using pear make-rpm-spec) doesn't need them anymore

* Sun Jun 15 2014 spuhler <spuhler> 1:1.9.4-11.mga5
+ Revision: 636645
- rebuild with new php

* Sat Oct 19 2013 umeabot <umeabot> 1:1.9.4-10.mga4
+ Revision: 527916
- Mageia 4 Mass Rebuild

* Fri Jun 14 2013 spuhler <spuhler> 1:1.9.4-9.mga4
+ Revision: 442945
- updated Archive_Tar_version to 1.3.11
-rebuilt against new php

* Sun Jan 13 2013 umeabot <umeabot> 1:1.9.4-8.mga3
+ Revision: 375876
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Dec 11 2012 spuhler <spuhler> 1:1.9.4-7.mga3
+ Revision: 329483
- bumped rel for rebuild against PHP-5.4.9

* Mon Sep 10 2012 oden <oden> 1:1.9.4-6.mga3
+ Revision: 291739
- rebuild

* Sun Sep 02 2012 spuhler <spuhler> 1:1.9.4-5.mga3
+ Revision: 287403
- removed the offending -n to make the script work, based on Oden

* Sat Jul 14 2012 spuhler <spuhler> 1:1.9.4-4.mga3
+ Revision: 270793
- Rebuild against PHP-5.4.4 and upgrade of Archive_Tar to version 1.3.10

* Sat Mar 03 2012 spuhler <spuhler> 1:1.9.4-3.mga2
+ Revision: 217383
- upgrade Archive_Tar to version 1.3.9
  upgraded XML_RPC to version 1.5.5

* Fri Nov 25 2011 spuhler <spuhler> 1:1.9.4-2.mga2
+ Revision: 171963
- upgrade Archive_Tar to version 1.3.8

* Sun Jul 10 2011 spuhler <spuhler> 1:1.9.4-1.mga2
+ Revision: 121947
- re-adding epoch: 1 otherwise it will not upgrade.
- upgrade from Version: 1.9.2 to 1.9.4
  using mdv spec file

* Wed May 18 2011 pterjan <pterjan> 1:1.9.2-3.mga1
+ Revision: 99689
- Add upstream fix for CVE-2011-1144

* Sun May 15 2011 pterjan <pterjan> 1:1.9.2-2.mga1
+ Revision: 99026
- Rebuild for fixed find-requires

* Thu Apr 14 2011 tv <tv> 1:1.9.2-1.mga1
+ Revision: 84931
- 1.9.2
- fix broken deps
- Console_Getopt-1.3.1
- Archive_Tar-1.3.7
- Structures_Graph-1.0.4
- XML_RPC-1.5.4

* Sat Jan 15 2011 spuhler <spuhler> 1:1.9.1-1.mga1
+ Revision: 19429
- changed rel to 1
- imported package php-pear
- changed release to 1
- imported package php-pear

